require 'mousebehav'
require 'keybindings'
require 'texture_animation'
require 'solidchecker'
require 'behaviour'
require 'definer'
require 'map_io'

function love.load()
	--constantly used: z, i, j,t 
	x,y,z,i,j,k,t,n = 0,0,0,0,0,0,0,0
	L,R,U,D = 0,0,0,0
	MouseX,MouseY = 0,0
	sg = 0
	
	MouseInIt = false	
	Max_col_length, Max_row_length = 32, 96		--total site
	ScreenSizeY, ScreenSizeX = 16, 24			--where you can see the main events: that is actually drawn
	
	GameField_OffsetX, GameField_OffsetY = 1, 1	--camera offsets	
	X_Beyond, Y_Beyond = 0,0					--debug variable for movemens
	ObjectCounter = 2							--counting objects to be able to put them without overwriting
	
	--uploading tileset of field and objects 
	TilesetPic = love.graphics.newImage('TILESET.png')
	ObjsetPic = love.graphics.newImage('OBJSET.png')	
	Tileset = { }	
	for j=1, 16 do
		for i=1, 16 do 
			Tileset[((i-1)*16)+j] = love.graphics.newQuad((j-1)*32, (i-1)*32, 32, 32, 512, 512)
		end
	end

	--uploading field
	Field_A = { }
	Field_B = { }	
	Field_C = { }	
	Field_D = { }	
	
	for j=1,Max_row_length do
	
	Field_A[j] = { }
	Field_B[j] = { }
	Field_C[j] = { }
	Field_D[j] = { }	
	
		for i=1, Max_col_length do
			Field_A[j][i] = 5 	--TILESET VALUE
			Field_B[j][i] = 16 	--OBJSET VALUE	
			Field_C[j][i] = 0 	--ID OF OBJECTS ON IT
			Field_D[j][i] = 16	--OBJSET VALUE 2
			
		end
	end

	Field_A[3][5] = 4 --TILESET VALUE
	Field_A[5][3] = 4 --TILESET VALUE	
	
	--creating  special objects that won't be on the Objects list
	Player = 
	{
	Name = "Player",
	X_Pos = 12,
	Y_Pos = 10,
	HP = 100,
	Current_Sprite_Num = 17,
	}	

	EditorCursor =
	{
	Current_Sprite_Num = 96,	
	X_Pos = 2,
	Y_Pos = 2,
	--define what you want to put down
	Selected_Tileset = false,
	Selected_Tilenum = 1,
	}	

	HUD_Arrow = { Left, Right }
			
	HUD_Arrow["Left"] = 	{Scr_X = 368, Scr_Y = 568, Current_Sprite_Num = 62 }	
	HUD_Arrow["Right"] = 	{Scr_X = 432, Scr_Y = 568, Current_Sprite_Num = 63 }		
	
	--defining objects in general
	Objects = { }
	ObjectsWire = { } --table for Wireworld

	--filling Objects with A LOT of Samples
	for y=1, 1525 do
	Objects[y] =
	{
	Type_ID = 0,
	Name = "'Sample'",
	X_Pos = 2,
	Y_Pos = 2,
	HP = 100,
	Current_Sprite_Num = 5,
	Can_I_Move = false,
	Generator = false,
	Wireworld_Num = 4,
	Last_Shocked = 0,
	}
	end	

	--definer
	Definer()
	
	for n=1,#Objects do
		--uploading Field_B: copy the current sprite number to own coords
		Field_B[Objects[n].X_Pos][Objects[n].Y_Pos] = Objects[n].Current_Sprite_Num	
		
		--uploading Field_C: every single fields contain the ID of the object that lies on these coordinates on Field_B
		Field_C[Objects[n].X_Pos][Objects[n].Y_Pos] = n
	end	

end

function love.draw()

	--adding player texture
	Field_B[Player.X_Pos][Player.Y_Pos] = Player.Current_Sprite_Num
	--adding cursor texture
	Field_B[EditorCursor.X_Pos][EditorCursor.Y_Pos] = EditorCursor.Current_Sprite_Num
	--adding arrows
	love.graphics.drawq(ObjsetPic, Tileset[HUD_Arrow["Left"].Current_Sprite_Num], HUD_Arrow["Left"].Scr_X, HUD_Arrow["Left"].Scr_Y)
	love.graphics.drawq(ObjsetPic, Tileset[HUD_Arrow["Right"].Current_Sprite_Num], HUD_Arrow["Right"].Scr_X, HUD_Arrow["Right"].Scr_Y)
	
	--drawing out stuff (ALWAYS COMPARE FIELD NAME AND SETPIC BELONGS TO THAT)
	for j=1, ScreenSizeX do
		for i=1, ScreenSizeY do	
			--TILESET VALUE
			love.graphics.drawq(TilesetPic, Tileset[Field_A[j + GameField_OffsetX][i + GameField_OffsetY]], (j-1)*32+16, (i-1)*32+16)	
			--OBJSET VALUES
			love.graphics.drawq(ObjsetPic, Tileset[Field_B[j + GameField_OffsetX][i + GameField_OffsetY]], (j-1)*32+16, (i-1)*32+16)		
		
		end
	end
	
	if MouseInIt then
		love.graphics.print(MouseX..", "..MouseY.."\n"
		..ChosenTile_X..", "..ChosenTile_Y..", Objectnum:"..ObjectCounter.."\n"
		..X_Beyond..", "..Y_Beyond.."\ndt = "..sg,0,528)
	end
	
	--selected tileset + selected tilenum
	love.graphics.drawq(TilesetPic, Tileset[EditorCursor.Selected_Tilenum], 440, 536)		
	love.graphics.print("Selected tile: number "..EditorCursor.Selected_Tilenum, 480, 536)		
	love.graphics.print("Selected object: "..ObjectNameFunction(EditorCursor.Selected_Tilenum), 480, 552)	

	love.graphics.print("Left click to put down a tile\nRight click to put down an object", 480, 568)	
	
end

function love.update(dt)

	for n=1,#Objects do
		--uploading Field_B: copy the current sprite number to own coords
		Field_B[Objects[n].X_Pos][Objects[n].Y_Pos] = Objects[n].Current_Sprite_Num	
		
		--uploading Field_C: every single fields contain the ID of the object that lies on these coordinates on Field_B
		Field_C[Objects[n].X_Pos][Objects[n].Y_Pos] = n
	end	
	
	--clear Field_B tile of there's no Object there
	for j=1,Max_row_length do
		for i=1, Max_col_length do	
			if Field_C[j][i] == 0 then
				Field_B[j][i] = 16
			end
		end
	end
	
	--important functions
	Behaviour()		
	Wireworld()		
	MouseBehaviour()
	Texture_Animation()
	
	sg = dt
end

--function to call the name of certain object
function ObjectNameFunction(ID)

	ObjectNameList = { }
	ObjectNameList[1] = "'Wooden Box'"
	ObjectNameList[2] = "'Metal Box'"
	ObjectNameList[3] = "'Central Power Source'"
	ObjectNameList[4] = "'Wire'"
	ObjectNameList[5] = "'Lamp'"
	ObjectNameList[6] = "'Local Battery'"
	
	if ObjectNameList[ID] == nil then 
	return "'*Empty*'"
	else
	return ObjectNameList[ID]
	end

end




